﻿using System;
using System.Data;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace ProgressCellElement
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radGridView1.CreateCell += new GridViewCreateCellEventHandler(radGridView1_CreateCell);
        }

        private void radGridView1_CreateCell(object sender, GridViewCreateCellEventArgs e)
        {
            if (e.Column.Name == "Progress" && e.Row.Data is GridViewDataRowInfo)
            {
                e.CellType = typeof(GridProgressCellElement);
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.radGridView1.DataSource = GetDataSource();
        }

        private static DataTable GetDataSource()
        {
            DataTable table = new DataTable("table");
            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("Progress", typeof(int));

            table.Rows.Add(1, "John", 50);
            table.Rows.Add(2, "Michael", 30);
            table.Rows.Add(3, "Richard", 70);
            table.Rows.Add(4, "Oliver", 92);

            return table;
        }
    }
}
